//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;
namespace InterAppDomain
{
	public class Fault : MarshalByRefObject
	{
		public void DivideZero()
		{
			Console.WriteLine("In the application domain: {0} thread {1}", Thread.GetDomain().FriendlyName, Thread.CurrentThread.GetHashCode());
			Console.WriteLine("Generating a fault . . . ");

			int a = 0;
			int b = 1;
			int c = b/a;

			Console.WriteLine("Fault never occured.");
		}
		public void Exception()
		{
			Console.WriteLine("In the application domain: {0} thread {1}", Thread.GetDomain().FriendlyName, Thread.CurrentThread.GetHashCode());
			Console.WriteLine("Generating a fault . . . ");
			throw new ApplicationException("Throwing an exceptions in Fault.Exception()");
			Console.WriteLine("Fault never occured.");
		}
	}
}