//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

__gc class MyException : public System::ApplicationException
{
public:
	MyException() : System::ApplicationException()
	{
	}
	MyException(System::String __gc *msg) : System::ApplicationException(msg)
	{
	}
};

void ThrowMyException()
{
	throw new MyException(new System::String("This exception is thrown from ThrowMyException"));
	// throw new MyException;
}

// This is the entry point for this application
int wmain(void)
{
	try
	{
		ThrowMyException();
	}
	catch (MyException *e)
	{
		Console::WriteLine("Caught exception");
		Console::WriteLine(e->ToString());
	}
	__finally
	{
		Console::WriteLine("Finally");
	}

	try
	{
		ThrowMyException();
	}
	catch (...)
	{
		Console::WriteLine("Caught general exception");
	}
	__finally
	{
		Console::WriteLine("General exeption finally");
	}

	Console::WriteLine("Almost done");

	return 0;
}