//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
///////////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) Microsoft Corp 2001.  All rights reserved.
//
//  Run: To throw an exception from managed-code to unmanaged-code: set compiler to "Not using managed extensions" for sampledll and to "Assembly Support (/clr)" for NDPExceptions
//       To throw an exception from unmanaged-code to managed-code: set compiler to "Not using managed extensions" for NDPExceptions and to "Assembly Support (/clr)" for sampledll
//
//  Description: Shows how to throw and handle NDP Exceptions in C++
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Exception.h"

#ifdef _MANAGED
#using <mscorlib.dll>

using namespace System;
#endif

__declspec(dllimport) void thrower();

int main()
{
    try
	{
        thrower();
    }
    catch(const CException &e)
	{
        char  szCause[255];
		cout << "Caught " << endl;
		cout << e << endl;
    } 

    cout << "**DONE**\n";

    return 0;
}
