//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// COMFault.cpp : Implementation of CCOMFault

#include "stdafx.h"
#include "COMFault.h"


// CCOMFault


STDMETHODIMP CCOMFault::Fail(void)
{
	return HRESULT_FROM_WIN32(ERROR_ACCESS_DENIED);
}

STDMETHODIMP CCOMFault::FailWithErrorInfo(void)
{
	HRESULT hr = HRESULT_FROM_WIN32(ERROR_NOT_SUPPORTED);
	Error("This is a description of the error", __uuidof(ICOMFault), hr);
	return hr;
}
