Imports System
Imports System.IO

Module BasicExceptions
    Sub ThrowMyException()
        Throw New MyException("This exception is thrown from ThrowMyException")
    End Sub

    Sub ExceptionGenerator(ByVal i As Integer)
        Dim a As Integer
        Dim b As Integer
        Dim c As Integer

        Select Case i
            Case 0
                ' Custom Exception
                ThrowMyException()
            Case 1
                ' DivideByZero
                a = 0
                b = 1
                c = b \ a
            Case 2
                ' StackOverflow
                ExceptionGenerator(2)
            Case 3
                ' FileNotFound
                Throw New FileNotFoundException("Testing")
        End Select
    End Sub

    Sub Main()
        Dim i As Integer
        For i = 0 To 3 Step 1
            Try
                ExceptionGenerator(i)
            Catch e As Exception
                'Any necessary tasks can be done before the exception is sent back to the caller
                Console.WriteLine("Exception Caught")
                Console.WriteLine(e.ToString())
            Finally
                'The Finally code will execute, even if an exception was thrown
                Console.WriteLine()
            End Try
        Next
    End Sub

End Module
