//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the UNMANAGEDFAULT_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// UNMANAGEDFAULT_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef UNMANAGEDFAULT_EXPORTS
#define UNMANAGEDFAULT_API __declspec(dllexport)
#else
#define UNMANAGEDFAULT_API __declspec(dllimport)
#endif

extern "C"
{
	UNMANAGEDFAULT_API int Custom(void);
	UNMANAGEDFAULT_API int Fail(void);
	UNMANAGEDFAULT_API int DivideByZero(void);
	UNMANAGEDFAULT_API int MemoryAccess(void);
	UNMANAGEDFAULT_API DWORD Win32Error(void);
}
